﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=4.01
@EndOfDesignText@
'version 2.01
#Event: ItemClick (Place As PlaceData)
#DesignerProperty: Key: HighlightColor, DisplayName: Highlight Color, FieldType: Color, DefaultValue: 0xFFFD5C5C
#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFF000000
Sub Class_Globals
	Public et As TextField
	Public lv As TableView
	Private mCallback As Object
	Private mEventName As String
	Private mBase As WeakRef
	Private keyboardHeight As Int
	Private QueryIndexSent, QueryIndexReceived As Int
	Private highlightColor As Int = 0xFFFD5C5C
	Private textColor As Int
	Private Const DefaultColorConstant As Int = -984833 'ignore
	Type PlaceData (Description As String, Id As String, DescriptionNormalized As String)
End Sub

'Initializes the object and sets the module and sub that will handle the ItemClick event
Public Sub Initialize (Callback As Object, EventName As String)
	et.Initialize("et")
	et.ShowClearButton = True
	'et.BorderStyle = et.STYLE_BEZEL
	'et.BorderStyle = et.STYLE_LINE
	et.BorderStyle = et.STYLE_ROUNDEDRECT
	lv.Initialize("lv", False)
	lv.Visible = False
	mCallback = Callback
	mEventName = EventName
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase.Value = Base
	'In this case the views are added to the parent instead of the base panel.
	'This is required as we don't want the base panel to "steal" touch events when the TableView is hidden.
	'UserInteractionEnabled property affects all child views. So we must move the list and text field.
	Base.UserInteractionEnabled = False
	Dim parent As Panel = Base.Parent
	parent.AddView(et, Base.Left, Base.Top, Base.Width, 50dip)
	parent.AddView(lv, Base.Left, Base.Top + et.Height, Base.Width, Base.Height - et.Height)
	highlightColor = Props.Get("HighlightColor")
	textColor = Props.Get("TextColor")
	et.TextColor = textColor
	et_TextChanged("", "")
	et.SetBorder(0, 0, 0)
End Sub

Public Sub KeyboardState(Height As Int)
	keyboardHeight = Height
	Base_Resize(GetBase.Width, GetBase.Height)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	et.SetLayoutAnimated(0, 1, GetBase.Left, GetBase.Top, Width, 50dip)
	lv.SetLayoutAnimated(0, 1, GetBase.Left, GetBase.Top + et.Height, Width, _
		Min(GetBase.CalcRelativeKeyboardHeight(keyboardHeight) - et.Height, GetBase.Height - et.Height))
End Sub

Public Sub GetBase As Panel
	Return mBase.Value
End Sub


Private Sub lv_SelectedChanged (SectionIndex As Int, Cell As TableCell)
	LogColor("SELECTED auto",Colors.Red)
	Dim pd As PlaceData = Cell.Tag
	et.Text = pd.Description
	lv.Visible = False
	et.ResignFocus
	CallSubDelayed2(mCallback, mEventName & "_ItemClick", pd)
End Sub

Private Sub et_TextChanged (Old As String, New As String)
	If New.Length = 0 Then
		lv.Clear
		lv.Visible = False
	Else
		If lv.Visible = False Then lv.Visible = True
		Dim j As HttpJob
		j.Initialize("", Me)
		j.Download2("https://maps.googleapis.com/maps/api/place/autocomplete/json", _
			Array As String("input", New, "key", Main.GoogleApiKey))
		QueryIndexSent = QueryIndexSent + 1
		Dim index As Int = QueryIndexSent
		Wait For (j) JobDone (j As HttpJob)
		If j.Success Then
			If QueryIndexReceived > index Then
				Return
			Else
				Dim pds As List
				pds.Initialize
				lv.Clear
				QueryIndexReceived = index
				Dim jp As JSONParser
				jp.Initialize(j.GetString)
				Dim m As Map = jp.NextObject
				Dim predictions As List = m.Get("predictions")
				For Each pred As Map In predictions
					Dim pd As PlaceData
					pd.Initialize
					pd.Id = pred.Get("place_id")
					pd.Description = pred.Get("description")
					pds.Add(pd)
				Next
				AddItemsToList(pds, New.ToLowerCase)
			End If
		End If
		j.Release
	End If
End Sub

Private Sub AddItemsToList(li As List, full As String)
	If li.IsInitialized = False Then Return
	Dim cs As CSBuilder
	For Each Item As PlaceData In li
		Dim desc As String = Item.Description
		Dim x As Int = desc.ToLowerCase.IndexOf(full)
		If x = -1 Then
			Continue
		End If
		cs.Initialize.Append(desc.SubString2(0, x)).Color(highlightColor).Append(desc.SubString2(x, x + full.Length)).Pop
		cs.Append(desc.SubString(x + full.Length))
		Dim tc As TableCell = lv.AddSingleLine("")
		tc.Text = cs
		tc.Tag = Item
	Next
	lv.ReloadAll
End Sub

Sub Normalize (text As String) As String
	text = text.Replace ("ě","e")
	text = text.Replace ("š","s")
	text = text.Replace ("č","c")
	text = text.Replace ("ř","r")
	text = text.Replace ("ž","z")
	text = text.Replace ("ý","y")
	text = text.Replace ("á","a")
	text = text.Replace ("í","i")
	text = text.Replace ("é","e")
	text = text.Replace ("ú","u")
	text = text.Replace ("ů","u")
	text = text.Replace ("ť","t")
	text = text.Replace ("š","s")
	text = text.Replace ("ď","d")
	text = text.Replace ("ľ","l")
	text = text.Replace ("ň","n")
	
	text = text.Replace ("Ě","E")
	text = text.Replace ("Š","S")
	text = text.Replace ("Č","C")
	text = text.Replace ("Ř","R")
	text = text.Replace ("Ž","Z")
	text = text.Replace ("Ý","Y")
	text = text.Replace ("Á","A")
	text = text.Replace ("Í","I")
	text = text.Replace ("É","E")
	text = text.Replace ("Ú","U")
	text = text.Replace ("Ů","U")
	text = text.Replace ("Ť","T")
	text = text.Replace ("Š","S")
	text = text.Replace ("Ď","D")
	text = text.Replace ("Ľ","L")
	text = text.Replace ("Ň","N")
	Return text
End Sub




''version 2.01
'#Event: ItemClick (Place As PlaceData)
'#DesignerProperty: Key: HighlightColor, DisplayName: Highlight Color, FieldType: Color, DefaultValue: 0xFFFD5C5C
'#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFF000000
'Sub Class_Globals
'	Public et As TextField
'	Public lv As TableView
'	Private mCallback As Object
'	Private mEventName As String
'	Private mBase As WeakRef
'	Private keyboardHeight As Int
'	Private QueryIndexSent, QueryIndexReceived As Int
'	Private highlightColor As Int = 0xFFFD5C5C
'	Private textColor As Int
'	Private Const DefaultColorConstant As Int = -984833 'ignore
'	Type PlaceData (Description As String, Id As String)
'End Sub
'
''Initializes the object and sets the module and sub that will handle the ItemClick event
'Public Sub Initialize (Callback As Object, EventName As String)
'	et.Initialize("et")
'	et.ShowClearButton = True
'	et.BorderStyle = et.STYLE_BEZEL
'	lv.Initialize("lv", False)
'	lv.Visible = False
'	mCallback = Callback
'	mEventName = EventName
'End Sub
'
'Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
'	mBase.Value = Base
'	'In this case the views are added to the parent instead of the base panel.
'	'This is required as we don't want the base panel to "steal" touch events when the TableView is hidden.
'	'UserInteractionEnabled property affects all child views. So we must move the list and text field.
'	Base.UserInteractionEnabled = False
'	Dim parent As Panel = Base.Parent
'    parent.AddView(et, Base.Left, Base.Top, Base.Width, 50dip)
'	parent.AddView(lv, Base.Left, Base.Top + et.Height, Base.Width, Base.Height - et.Height)
'	highlightColor = Props.Get("HighlightColor")
'	textColor = Props.Get("TextColor")
'	et.TextColor = textColor
'	et_TextChanged("", "")
'	et.SetBorder(0, 0, 0)
'End Sub
'
'Public Sub KeyboardState(Height As Int)
'	keyboardHeight = Height
'	Base_Resize(GetBase.Width, GetBase.Height)
'End Sub
'
'Private Sub Base_Resize (Width As Double, Height As Double)
'	et.SetLayoutAnimated(0, 1, GetBase.Left, GetBase.Top, Width, 50dip)
'	lv.SetLayoutAnimated(0, 1, GetBase.Left, GetBase.Top + et.Height, Width, _ 
'		Min(GetBase.CalcRelativeKeyboardHeight(keyboardHeight) - et.Height, GetBase.Height - et.Height))
'End Sub
'
'Public Sub GetBase As Panel
'	Return mBase.Value
'End Sub
'
'
'Private Sub lv_SelectedChanged (SectionIndex As Int, Cell As TableCell)
'	Dim pd As PlaceData = Cell.Tag
'	et.Text = pd.Description
'	lv.Visible = False
'	et.ResignFocus
'	CallSubDelayed2(mCallback, mEventName & "_ItemClick", pd)
'End Sub
'
'Private Sub et_TextChanged (Old As String, New As String)
'	Private link As String = "https://autocomplete.geocoder.api.here.com/6.2/suggest.json?app_id=GA4MpuVX08JybyQvkUM9&app_code=2g8WsPddTnsCn6k2DChMNA&query=" & New 
'	LogColor(link, Colors.Magenta)
'	If New.Length = 0 Then
'		lv.Clear
'		lv.Visible = False
'	Else
'		If lv.Visible = False Then lv.Visible = True
'		Dim j As HttpJob
'		j.Initialize("", Me)
'		'j.Download2("https://maps.googleapis.com/maps/api/place/autocomplete/json", _
'		'	Array As String("input", New, "key", Main.GoogleApiKey))
'		j.Download(link)
'		
'		QueryIndexSent = QueryIndexSent + 1
'		Dim index As Int = QueryIndexSent
'		Wait For (j) JobDone (j As HttpJob)
'		If j.Success Then
'			If QueryIndexReceived > index Then
'				Return
'			Else
'				Dim pds As List
'				pds.Initialize
'				lv.Clear
'				QueryIndexReceived = index
'				Dim jp As JSONParser
'				jp.Initialize(j.GetString)
'				Dim m As Map = jp.NextObject
'				Dim m1 As Map
'				Dim predictions As List = m.Get("suggestions")
'				For Each pred As Map In predictions
'					
'					m1 = pred.Get("address")
'					'LogColor(m1,Colors.Cyan)
'					
'					Dim street As String
'					If m1.Get("street") <> Null Then
'						street = m1.Get("street")
'					End If
'					
'					Dim houseNumber As String
'					If m1.Get("houseNumber") <> Null Then
'						houseNumber = m1.Get("houseNumber")
'					End If
'					
'					Dim city As String
'					If m1.Get("city") <> Null Then
'						city = m1.Get("city")
'					End If
'					
'					Dim country As String
'					If m1.Get("country") <> Null Then
'						country = m1.Get("country")
'					End If
'					
'					Dim locationID As String = pred.Get("locationId")
'					Dim AdresaMoje As String
'					
'					If street <> "" Then
'						AdresaMoje = street
'					End If
'					
'					If houseNumber <> "" Then
'						AdresaMoje = AdresaMoje & " "  & houseNumber
'					End If
'					
'					If houseNumber <> "" Or street <> "" Then
'						AdresaMoje = AdresaMoje & ", "
'					End If
'					
'					If city <> "" Then
'						AdresaMoje = AdresaMoje & city & ", "
'					End If
'					
'					If country <> "" Then
'						AdresaMoje = AdresaMoje & country
'					End If
'					
'					LogColor(AdresaMoje,Colors.Yellow)
'					
'					Dim pd As PlaceData
'					pd.Initialize
'					pd.Id = locationID
'					pd.Description = AdresaMoje
''					pd.DescriptionNormalized = Normalize(AdresaMoje)
'					pds.Add(pd)
'				Next
'				AddItemsToList(pds, New.ToLowerCase)
'			End If
'		End If
'		j.Release
'	End If
'End Sub
'
''Private Sub et_TextChanged (Old As String, New As String)
''	If New.Length = 0 Then
''		lv.Clear
''		lv.Visible = False
''	Else
''		If lv.Visible = False Then lv.Visible = True
''		Dim j As HttpJob
''		j.Initialize("", Me)
''		j.Download2("https://maps.googleapis.com/maps/api/place/autocomplete/json", _
''			Array As String("input", New, "key", Main.GoogleApiKey))
''		QueryIndexSent = QueryIndexSent + 1
''		Dim index As Int = QueryIndexSent
''		Wait For (j) JobDone (j As HttpJob)
''		If j.Success Then
''			If QueryIndexReceived > index Then
''				Return
''			Else
''				Dim pds As List
''				pds.Initialize
''				lv.Clear
''				QueryIndexReceived = index
''				Dim jp As JSONParser
''				jp.Initialize(j.GetString)
''				Dim m As Map = jp.NextObject
''				Dim predictions As List = m.Get("predictions")
''				For Each pred As Map In predictions
''					Dim pd As PlaceData
''					pd.Initialize
''					pd.Id = pred.Get("place_id")
''					pd.Description = pred.Get("description")
''					pds.Add(pd)
''				Next
''				AddItemsToList(pds, New.ToLowerCase)
''			End If
''		End If
''		j.Release
''	End If
''End Sub
'
'Private Sub AddItemsToList(li As List, full As String)
'	If li.IsInitialized = False Then Return
'	Dim cs As CSBuilder
'	For Each Item As PlaceData In li
'		Dim desc As String = Item.Description
'		Dim x As Int = desc.ToLowerCase.IndexOf(full)
'		If x = -1 Then
'			Continue
'		End If
'		cs.Initialize.Append(desc.SubString2(0, x)).Color(highlightColor).Append(desc.SubString2(x, x + full.Length)).Pop
'		cs.Append(desc.SubString(x + full.Length))
'		Dim tc As TableCell = lv.AddSingleLine("")
'		tc.Text = cs
'		tc.Tag = Item
'	Next
'	lv.ReloadAll
'End Sub
'
'
